unit main;

interface

uses
  {$IFNDEF FPC}Windows, {$ELSE}LResources, {$ENDIF} SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, dx_scene, dx_objects, dx_controls, dx_utils, ExtCtrls,
  dx_vglayer, dx_vgcore;

type
  TForm4 = class(TForm)
    dxScene1: TdxScene;
    Root1: TdxVisualObject;
    SceneBitmap: TdxBitmapObject;
    Location: TdxDummy;
    Camera1: TdxCamera;
    Light1: TdxLight;
    dxBitmapList1: TdxBitmapList;
    Cube1: TdxCube;
    Scene: TdxDummy;
    Cube2: TdxCube;
    Cube3: TdxCube;
    Bat: TdxCube;
    Ball: TdxSphere;
    RoundCube1: TdxRoundCube;
    Timer1: TTimer;
    Sphere1: TdxSphere;
    Trigger: TdxCube;
    RoundCube2: TdxRoundCube;
    RoundCube3: TdxRoundCube;
    RoundCube4: TdxRoundCube;
    RoundCube5: TdxRoundCube;
    RoundCube6: TdxRoundCube;
    RoundCube7: TdxRoundCube;
    ObjectLayer1: TdxObjectLayer;
    Root2: TvxLayout;
    Rectangle2: TvxRectangle;
    Text1: TvxText;
    Text2: TvxText;
    Rectangle3: TvxRectangle;
    Back: TdxGUIImage;
    procedure dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure BallCollision(Sender: TObject;
      CollisionObject: TdxVisualObject; Point, Normal: TdxVector);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
    OldX: single;
  public
    { Public declarations }
  end;

var
  Form4: TForm4;

implementation

{$R *.dfm}

procedure TForm4.dxScene1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if OldX = 0 then OldX := X;
  Bat.Position.X := Bat.Position.X + (X - OldX) * 0.05;
  Bat.Position.X := ((x - (dxScene1.Width / 2)) / dxScene1.Width) * 10;
  if Bat.Position.X < -5 then
    Bat.Position.X := -5;
  if Bat.Position.X > 5 then
    Bat.Position.X := 5;
  OldX := X;
end;

procedure TForm4.dxScene1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  P: TdxVector;
begin
  if Ball.Parent = Bat then
  begin
    P := Ball.AbsolutePosition;
    Ball.Position.Vector := Ball.AbsolutePosition;
    Ball.Parent := Scene;
    Ball.Velocity.Vector := dxVector(0, 5, 0);
  end;
end;

procedure TForm4.BallCollision(Sender: TObject;
  CollisionObject: TdxVisualObject; Point, Normal: TdxVector);
begin
  { ball collise }
  // first back to disable collision
  Ball.Back;
  if CollisionObject = Bat then
  begin
    // reflect velocity
    Ball.Velocity.Vector := Ball.AbsoluteToLocalVector(dxVector((Ball.Position.X - Bat.Position.X) * 3, 4, 0, 0));
  end
  else
  if CollisionObject = Trigger then
  begin
    // ball death
    Ball.Parent := Bat;
    Ball.Position.Vector := dxVector(0, 0.6, 0);
    Ball.Velocity.Vector := dxVector(0, 0, 0);
  end
  else
  if CollisionObject.Tag = 1 then
  begin
    //
    if CollisionObject.Dynamic then
      CollisionObject.AddForce(dxVectorScale(Ball.LocalToAbsoluteVector(Ball.Velocity.Vector), 1))
    else
    begin
      CollisionObject.Opacity := 0;
      CollisionObject.Free;
    end;
    // reflect velocity
    Normal.W := 0;
    Normal.Z := 0;
    Normal := Ball.AbsoluteToLocalVector(Normal);
    Ball.Velocity.Vector := dxVectorReflect(Ball.Velocity.Vector, Normal);
  end
  else
  begin
    // reflect velocity
    Normal.W := 0;
    Normal.Z := 0;
    Normal := Ball.AbsoluteToLocalVector(Normal);
    Ball.Velocity.Vector := dxVectorReflect(Ball.Velocity.Vector, Normal);
  end;
end;

procedure TForm4.Timer1Timer(Sender: TObject);
begin
  Text2.Text := IntToStr(Round(dxScene1.Fps)) + ' FPS';
end;

end.
